#*************************estimate function using grm**************
#if omit==T, omit second-order chi-square computed by the inverse matrix
#if adjust==T, will put a cap on the parameter estimates
#if adjust_w is not zero, will add the value of adjust_w to the diagnal of w matrix to make sure it is not singular
# usually I just set adjust=F and adjust_w=0. The usage of them need to be studied carefully.

estimate_func_grm<-function(samp=1,omit=TRUE,adjust=F,adjust_w){
  print(samp)
  iresp <- iresp1[(1+n*(samp-1)):(n*samp),]
  #iresp<-iresp1
  iresp<-as.matrix(iresp)
# grm *****************************************
grmresult<-grm(iresp,Hessian=TRUE)
hess <- grmresult$hess
  #print(hess)
infor <- ginv(hess)
  #print(infor)
para<-NULL
for(i in 1:npo){
para<-rbind(para,grmresult$coefficients[[i]])
 }
 thr<-t(para[,1:(szo-1)])
 a1<-t(para[,szo])

  if(adjust==T){
    for(i in 1:npo){
      if(a1[1,i]>3.5){a1[1,i]<-3.5}
    }
  }
  print("thresholds")
  print(thr)
  print("slopes")
  print(a1)
  vinc=0   #for one factor model, always zero
  #***********nodes used to compute intergral**************8
  z   <- array(0,nq)               # quadrature nodes
  w2  <- array(0,ncol1)            # quadrature weights
  zex <- array(0,c(ncol1,nfac))    # grid quadrature nodes
  #*** Gauss Hermite quadrature ********************************************
  
  gh1 <- gaussHermiteData(nq)
  z  <- gh1$x*sqrt(2)                 #GH nodes
  w  <- gh1$w/sqrt(pi)                #GH weights
  
  if (nfac>1){
    zex<-z_ext(z,nfac)            # N(0,I)
    w1<-z_ext(w,nfac)             # disposizioni con ripetizione of weights
    w2 <- apply(w1,1,prod)
  }else{zex<-z
  zex<-as.matrix(zex)
  w2<-w
  w2<-as.matrix(w2)
  } 
  
  # Compute the estimated probabilities associated to the overall response patterns (observed and not observed)
  out_tot<-Estep(ncol1,szo,iresp_tot,thr,a1,zex,w2)  
  pl_tot<-out_tot$pl         # \pi(obs)
  pjoin_tot<-out_tot$pjoin   # f(obs,lat)
  phioc_tot<-out_tot$phioc
  ###**************Compute the observed frequencies associated to each response pattern*********************************
  
  fr_tot<-array(0,n_tot)
  for (k in 1:n_tot) {
    mat1<-matrix(rep(iresp_tot[k,],n),n,npo,byrow=TRUE)  #this method is much faster than others!!
    fr_tot[k]<-sum(rowSums(iresp==mat1)==npo)
    
  }
  
  
  #******some matrix to compute statistics**********  
  dg<-npo*(nfac+szo-1)-vinc
  G<- array(0, c(n_tot,dg))  # matrix of first derivatives  A  
  dyn.load("gfi.so")
  
  storage.mode(n)="integer"
  storage.mode(n_tot)="integer"
  storage.mode(dg)="integer"
  storage.mode(npo)="integer"
  storage.mode(nfac)="integer"
  storage.mode(szo)="integer"
  storage.mode(ncol1)="integer"
  storage.mode(iresp_tot)="double"
  storage.mode(pjoin_tot)="double"
  storage.mode(phioc_tot)="double"
  storage.mode(zex)="double"
  storage.mode(G)="double"
  
  outderG   <- function(iresp,nfac,szo,npo,n,n_tot,ncol1,dg,pjoinc,phioc,zex,G)
  {res<-.Fortran("dera",iresp,nfac,szo,npo,n,n_tot,ncol1,dg,pjoinc,phioc,zex,G=G)
  } 
  derG<-outderG(iresp_tot,nfac,szo,npo,n,n_tot,ncol1,dg,pjoin_tot,phioc_tot,zex,G)    
  G<-derG$G  
  
  #A=diag(pl_tot^(-1/2))%*%G
  Pi<-sparseMatrix(i=c(1:n_tot),j=c(1:n_tot),x=pl_tot)
  A<-sparseMatrix(i=c(1:n_tot),j=c(1:n_tot),x=pl_tot^(-1/2))%*%G
  
  
  #*********compute delta and lambda for theoretical power************
  
  #W<-diag(n_tot)-sqrt(pl_tot)%*%sqrt(t(pl_tot))-A%*%solve(t(A)%*%A)%*%t(A)
  #B<-W%*%diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])   #diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])<=>each row of t(Msecondfull[keep,]) times the correspond diagnal element
  
  #let temp=diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])
  #compute t(temp) first since if compute temp directly, in every iteration need to compute t(Msecondfull[keep,]), time consuming, more than 100 times!
  
  #temp<-matrix(NA,nrow=length(keep),ncol=length(pl_tot))
  #for(i in 1:length(pl_tot)){
  #  temp[,i]=Msecondfull[keep,i]*(pl_tot[i])^(1/2)
  #}
  #temp=t(temp)
  temp<-sparseMatrix(i=c(1:n_tot),j=c(1:n_tot),x=pl_tot^(1/2))%*%t(Msecondfull[keep,])
  I<-solve(t(A)%*%A)
  B<-as.matrix(temp-sqrt(pl_tot)%*%(sqrt(t(pl_tot))%*%temp)-A%*%I%*%(t(A)%*%temp)+adjust_w*temp)
  
  
  
  
  
  
  
  if(omit!=TRUE){
    Pi<-diag(pl_tot)
    Om_u<-Pi-pl_tot%*%t(pl_tot)-G%*%solve(t(A)%*%A)%*%t(G)  #Covariance matrix of unstandardized residuals
    #the omega in the paper is HOm_uH'
  }
  #####**************** Pearson chi square ***************** ######
  chisqPea<- n*sum((fr_tot/n-pl_tot)^2/pl_tot)
  #******* Reiser Chi square for ordinal data (1996)  *************
  if(omit!=TRUE){
    e=as.matrix(Msecondfull[keep,])%*%(fr_tot/n-pl_tot)
    Sigma_e<-as.matrix((1/n)*(Msecondfull[keep,])%*%Om_u%*%t(as.matrix(Msecondfull[keep,])))
    Chi_2<-t(e)%*%ginv(Sigma_e,tol=0.0001)%*%e
  }
  #******* Joe-Maydeu Chi square for ordinal data (2006)  *************
  # rbind(Mfirst,Msecondfull[keep,])=M don't store it in M to save memory
  if(omit!=TRUE){
    Delta_2<-rbind(Mfirst,as.matrix(Msecondfull[keep,]))%*%G
    Theta_2<-rbind(Mfirst,as.matrix(Msecondfull[keep,]))%*%(Pi-pl_tot%*%t(pl_tot))%*%t(rbind(Mfirst,as.matrix(Msecondfull[keep,])))
    invTheta2<-solve(Theta_2)
    C_2<-invTheta2-invTheta2%*%Delta_2%*%solve(t(Delta_2)%*%invTheta2%*%Delta_2)%*%t(Delta_2)%*%invTheta2
    e1<-rbind(as.matrix(Mfirst),as.matrix(Msecondfull[keep,]))%*%(fr_tot/n-pl_tot)
    M_2<-n*t(e1)%*%C_2%*%e1
  }
  #********************Reiser orthogonal components for bivariate residuals BJMSP 2008*******************
  z<-sqrt(n)*(fr_tot/n-pl_tot)/sqrt(pl_tot)
  #W<-diag(n_tot)-sqrt(pl_tot)%*%sqrt(t(pl_tot))-A%*%solve(t(A)%*%A)%*%t(A)
  #B<-W%*%diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])   #diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])<=>each row of t(Msecondfull[keep,]) times the correspond diagnal element
  
  #let temp=diag(pl_tot^(1/2))%*%t(Msecondfull[keep,])
  #compute t(temp) first since if compute temp directly, in every iteration need to compute t(Msecondfull[keep,]), time consuming, more than 100 times!
  
  
  
  ano<-anova(lm(z~B-1))
  chisqR<-ano$Sum[1]  #Sum of squares of bivariate residuals
  #********************Gffit *******************
  # two categories:as.matrix(M_ij) is a column vector
  # more than two categories:as.matrix(M_ij) are row vectors
  Gf_fit<-matrix(0, npo-1,npo)
  Gf_fit2<-matrix(0, npo-1,npo)
  Gf_fitO<-matrix(0, npo-1,npo)
  numcol<-dim(B)[2]
  f1<-"z~B[,1]"
  for(i in 2:numcol){
    f1<-paste(f1,"+B[,",i,"]",sep='')
  }
  f1<-paste(f1,"-1",sep='')
  F1<-as.formula(f1)
  typeISS<-anova(lm(F1))$Sum[1:numcol]
  for (i in 1:(npo-1)) {
    for (j in (i+1): npo) {
      Gf_fitO[i,j]<-sum(typeISS[c(index[,1]==i&index[,2]==j)])
    }
  }
  #   W<-diag(n_tot)-sqrt(pl_tot)%*%sqrt(t(pl_tot))-A%*%solve(t(A)%*%A)%*%t(A)
  #   z<-sqrt(n)*(fr_tot/n-pl_tot)/sqrt(pl_tot)
  #   h<-0
  #   for (i in 1:(npo-1)) {
  #     for (j in (i+1): npo) {
  #       M_ij<-Msecondfull[keep,][c(index[,1]==i&index[,2]==j),]
  #       if (szo==2) {M_ij<-t(as.matrix(M_ij))}
  #       else {M_ij<-as.matrix(M_ij)}
  #
  #       e_ij<-M_ij%*%(fr_tot/n-pl_tot)
  #       pl_ij<-as.vector(M_ij%*%pl_tot)
  #
  #       Gf_fit[i,j]<-n*sum(e_ij^2/pl_ij)                          #Moustaki and Joreskog
  #       if(i==1&j==2){
  #         B1<-W%*%diag(pl_tot^(1/2))%*%t(M_ij)
  #         an<-lm(z~B1-1)
  #         Gf_fitO[i,j]<-anova(an)$Sum[1]-h                          #Reiser orthogonal
  #         h<-sum(Gf_fitO)
  #         M_ijc<-M_ij}  else{
  #           M_ijc<-rbind(M_ijc,M_ij)
  #           B1<-W%*%diag(pl_tot^(1/2))%*%t(M_ijc)
  #
  #           an<-lm(z~B1-1)
  #           Gf_fitO[i,j]<-anova(an)$Sum[1]-h                          #Reiser orthogonal
  #           h<-sum(Gf_fitO) }
  #     }
  #   }
  #
  #
  if(omit!=TRUE){
    chisqCM<-c(chisqCM,Chi_2)    #Cagnone Mignani   (2007)
    chisqJO<-c(chisqJO,M_2)      #Joe Olivares      (2006)
    GffitMJ<-GffitMJ+Gf_fit       #Moustaki Joreskog  (2001)
  }
  
  chisqRe<-c(chisqRe,chisqR)   #Reiser orthogonal (2008)
  chisqPe<-c(chisqPe,chisqPea) #Pearson
  
  #GffitRE<-GffitRE+Gf_fitO      #Reiser   orthogonal (2012)
  GffitRE[,,samp]<-Gf_fitO       #get all the components
  #************chisqJO_ij and Pearson_ij(Pearson_ij does not distributed chisq)*********************
  df_ij<-szo^2-2*(szo-1+nfac)-1
  if(nfac==1){
    for (i in 1:(npo-1)) {
      for (j in (i+1): npo) {
        H_ij<-Msecondfull[c(indexfull[,1]==i&indexfull[,2]==j),] #actually M, not H?
        e_ij<-H_ij%*%as.vector(fr_tot/n-pl_tot)
        
        ##**************Pearson_ij***************##
        pl_ij=H_ij%*%pl_tot #pl_ij is the diagnal of D_ij
        x_ij<-n*sum((e_ij)^2/pl_ij)
        Pearson_ij[i,j,samp]<- x_ij
        thr_i<-((szo-1)*(i-1)+1):((szo-1)*(i-1)+szo-1)
        thr_j<-((szo-1)*(j-1)+1):((szo-1)*(j-1)+szo-1)
        para_ij<-c(thr_i,thr_j,(szo-1)*npo+i,(szo-1)*npo+j)
        G_ij<-G[,para_ij]
        I_ij<-I[para_ij,para_ij]
        delta_ij<-H_ij%*%G_ij
        #H_ij%*%G_ij is the delta_ij in the paper
        sigma_ij<-H_ij%*%Pi%*%t(H_ij)-(H_ij%*%pl_tot)%*%t(H_ij%*%pl_tot)-delta_ij%*%I_ij%*%t(delta_ij)
        D_ij_inv<-sparseMatrix(i=c(1:length(pl_ij)),j=c(1:length(pl_ij)),x=pl_ij^(-1))
        temp<-D_ij_inv%*%sigma_ij
        
        mu_1<-sum(diag(temp))
        mu_2<-2*sum(diag(temp%*%temp))
        mu_1_ij[i,j,samp]<-mu_1
        mu_2_ij[i,j,samp]<-mu_2
        
        x_bar_ij[i,j,samp]<-2*mu_1*x_ij/mu_2
        x_d_bar_ij[i,j,samp]<-x_ij*sqrt(2*df_ij/mu_2)+df_ij-sqrt(2*df_ij*(mu_1^2)/mu_2)
        #M_ij
        if(df_ij>0){
          
          
          C_ij_part<-D_ij_inv%*%delta_ij%*%solve(t(delta_ij)%*%D_ij_inv%*%delta_ij)%*%t(delta_ij)%*%D_ij_inv
          
#          chisqJO_ij[i,j,samp]<-as.numeric(x_ij-n*t(e_ij)%*%C_ij_part%*%e_ij) #may not be correct
          chisqJO_ij[i,j,samp]<-as.numeric(x_ij) #may not be correct
        }
      }
    }
  }else{
    for (i in 1:(npo-1)) {
      for (j in (i+1): npo) {
        H_ij<-Msecondfull[c(indexfull[,1]==i&indexfull[,2]==j),]
        if (szo==2) {H_ij<-t(as.matrix(H_ij))}
        else {H_ij<-as.matrix(H_ij)}
        e_ij<-H_ij%*%(fr_tot/n-pl_tot)
        
        if(omit!=TRUE){
          if(i==1){
            Delta_ij<-H_ij%*%G[,c(((szo-1)*(i-1)+1):((szo-1)*(i-1)+szo-1),((szo-1)*(j-1)+1):((szo-1)*(j-1)+szo-1),npo*(szo-1)+1,(npo*(szo-1)+1+nfac*(j-2)+1):(npo*(szo-1)+1+nfac*(j-2)+nfac))]
            ##choose parameters to do deriv       thr for vi                        thr for vj
          }else{
            Delta_ij<-H_ij%*%G[,c(((szo-1)*(i-1)+1):((szo-1)*(i-1)+szo-1),((szo-1)*(j-1)+1):((szo-1)*(j-1)+szo-1),(npo*(szo-1)+1+nfac*(i-2)+1):(npo*(szo-1)+1+nfac*(i-2)+nfac),(npo*(szo-1)+1+nfac*(j-2)+1):(npo*(szo-1)+1+nfac*(j-2)+nfac))]
          }
          #Theta_ij<-H_ij%*%(Pi-pl_tot%*%t(pl_tot))%*%t(H_ij)
          D_ij<-H_ij%*%(Pi)%*%t(H_ij)
          U_ij<-solve(D_ij)-solve(D_ij)%*%Delta_ij%*%solve(t(Delta_ij)%*%solve(D_ij)%*%Delta_ij)%*%t(Delta_ij)%*%solve(D_ij)
          
          chisqJO_ij[i,j,samp]<-n*t(e_ij)%*%U_ij%*%e_ij
        }
        ##**************Pearson_ij***************##
        pl_ij=H_ij%*%pl_tot
        Pearson_ij[i,j,samp]<- n*sum((e_ij)^2/pl_ij)
      }
    }
  }
  
  #****finish************
  dyn.unload("gfi.so")
  #******** Mean of Gffit of the Monte Carlo distribution *******************
  #GffitMJ<-GffitMJ/nsamp
  if(omit!=TRUE){
    return(list(A=A,para=para,chisqPea=chisqPea,chisqR=chisqR,M_2=M_2,chisqJO_ij=chisqJO_ij[,,samp],
                Gf_fitO=Gf_fitO,error=NULL,
                Pearson_ij=Pearson_ij[,,samp],typeISS=typeISS,x_d_bar_ij=x_d_bar_ij[,,samp],x_bar_ij=x_bar_ij[,,samp],
                fr_tot=fr_tot,pl_tot=pl_tot,mu_1_ij=mu_1_ij[,,samp],mu_2_ij=mu_2_ij[,,samp]))
  }else{
    return(list(A=A,para=para,chisqPea=chisqPea,chisqR=chisqR,
                Gf_fitO=Gf_fitO,error=NULL,
                Pearson_ij=Pearson_ij[,,samp],typeISS=typeISS,x_d_bar_ij=x_d_bar_ij[,,samp],x_bar_ij=x_bar_ij[,,samp],
                fr_tot=fr_tot,pl_tot=pl_tot,mu_1_ij=mu_1_ij[,,samp],mu_2_ij=mu_2_ij[,,samp],chisqJO_ij=chisqJO_ij[,,samp]))
  }
} 
